unit SysInit;

interface

var
  _HandleFinally : Byte;

// API
const
  kernel32 = 'kernel32.dll';
  user32 = 'user32.dll';
  gdi32 = 'gdi32.dll';
  opengl32 = 'opengl32.dll';
  
  GL_DEPTH_BUFFER_BIT   = $00000100;
  GL_COLOR_BUFFER_BIT   = $00004000; 
  GL_QUADS              = $0007;
  GL_TEXTURE_2D         = $0DE1;  
  GL_UNSIGNED_BYTE      = $1401;
  GL_LUMINANCE          = $1909;  
  GL_TEXTURE_MIN_FILTER = $2801;  
  GL_LINEAR             = $2601;

  
  procedure ExitProcess(uExitCode: Cardinal); stdcall; external kernel32 name '_ExitProcess@4';
  function GetTickCount: Cardinal; stdcall; external kernel32 name '_GetTickCount@0';
  
  function CreateWindowEx(dwExStyle: Cardinal; lpClassName: PChar;
                           lpWindowName: PChar; dwStyle: Cardinal; X, Y, nWidth, nHeight: LongInt;
                           hWndParent, hMenu, hInstance: Cardinal; lpParam: Pointer): Cardinal; stdcall; external user32 name '_CreateWindowExA@48';
  function PeekMessage(lpMsg: Pointer; hWnd, wMsgFilterMin, wMsgFilterMax, wRemoveMsg: Cardinal): Boolean; stdcall; external user32 name '_PeekMessageA@20';
  function GetAsyncKeyState(vKey: LongInt): SmallInt; stdcall; external user32 name '_GetAsyncKeyState@4';
  function GetDC(hWnd: Cardinal): Cardinal; stdcall; external user32 name '_GetDC@4';
  
  function ChoosePixelFormat(DC: Cardinal; p2: Pointer): LongInt; stdcall; external gdi32 name '_ChoosePixelFormat@8';
  function SetPixelFormat(DC: Cardinal; PixelFormat: LongInt; FormatDef: Pointer): Boolean; stdcall; external gdi32 name '_SetPixelFormat@12';
  function SwapBuffers(DC: Cardinal): Boolean; stdcall; external gdi32 name '_SwapBuffers@4';
  
  function wglCreateContext(DC: Cardinal): Cardinal; stdcall; external opengl32 name '_wglCreateContext@4';
  function wglMakeCurrent(DC, p2: Cardinal): Boolean; stdcall; external opengl32 name '_wglMakeCurrent@8';  
  procedure glEnable(cap: Cardinal); stdcall; external opengl32 name '_glEnable@4';
  procedure glClear(mask: Cardinal); stdcall; external opengl32 name '_glClear@4';  
  procedure glLoadIdentity; stdcall; external opengl32 name '_glLoadIdentity@0';
  procedure glRotatef(angle, x, y, z: Single); stdcall; external opengl32 name '_glRotatef@16';    
  procedure glTexImage2D(target: Cardinal; level, components, width, height, border: LongInt; format, _type: Cardinal; data: Pointer); stdcall; external opengl32 name '_glTexImage2D@36';
  procedure glTexParameteri(target, pname: Cardinal; param: LongInt); stdcall; external opengl32 name '_glTexParameteri@12';
  procedure glBegin(mode: Cardinal); stdcall; external opengl32 name '_glBegin@4';
  procedure glEnd; stdcall; external opengl32 name '_glEnd@0';
  procedure glVertex2s(x, y: SmallInt); stdcall; external opengl32 name '_glVertex2s@8';
  procedure glColor4ub(r, g, b, a: Byte); stdcall; external opengl32 name '_glColor4ub@16';
  procedure glTexCoord2s(s, t: SmallInt); stdcall; external opengl32 name '_glTexCoord2s@8';  
  procedure glOrtho(left, right, bottom, top, znear, zfar: Double); stdcall; external opengl32 name '_glOrtho@48';
  
implementation

var
  DC  : Cardinal;
  pfd : array [0..9] of Cardinal;
  Msg : array [0..4] of Cardinal;
  Tex : array [0..256 * 256 - 1] of Byte;
  i : Integer;
initialization
// Init OpenGL
  pfd[1] := $25;
  DC := GetDC(CreateWindowEx(0, 'static', nil, Cardinal($90000000), 0, 0, 640, 480, 0, 0, 0, nil));
  SetPixelFormat(DC, ChoosePixelFormat(DC, @pfd), @pfd);
  wglMakeCurrent(DC, wglCreateContext(DC));
// Init Texture
  for i := 0 to 256 * 256 - 1 do
    Tex[i] := (i mod 256) xor (i div 256);
  glEnable(GL_TEXTURE_2D);
  glTexImage2D(GL_TEXTURE_2D, 0, 1, 256, 256, 0, GL_LUMINANCE, GL_UNSIGNED_BYTE, @Tex);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
// Main Loop 
  repeat
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
    glLoadIdentity;  
    glOrtho(-4, 4, -3, 3, 0, 1);
    glRotatef(GetTickCount mod 360000 / 10, 0, 0, 1);
  // Draw Quad
    glBegin(GL_QUADS);
      glTexCoord2s(0, 0); glColor4ub(255, 0, 0, 255); glVertex2s(-2, -2);
      glTexCoord2s(1, 0); glColor4ub(0, 255, 0, 255); glVertex2s( 2, -2);
      glTexCoord2s(1, 1); glColor4ub(0, 0, 255, 255); glVertex2s( 2,  2);
      glTexCoord2s(0, 1); glColor4ub(80, 0, 80, 255); glVertex2s(-2,  2);
    glEnd;
    SwapBuffers(DC);    
    PeekMessage(@Msg, 0, 0, 0, 1);
  until (GetAsyncKeyState(27) <> 0);
  ExitProcess(0);
end. 
